% This toolbox implements several hyperspectral clustering algorithms 
% develped by James M. Murphy (Tufts University) and Mauro Maggioni 
% (Johns Hopkins University). The algorithms implemented are:
%
% 1.)  Diffusion Learning (DL)
% 2.)  Spectral-Spatial Diffusion Learning (DLSS)
% 3.)  Spatially-Regularized Diffusion Learning (SRDL)
%
% Those who wish to use and edit this code are free to do so.  We request 
% that if this code is used in any way for a publication, the following 
% papers be cited:
%
% -Murphy, James M., and Mauro Maggioni. 
% "Unsupervised Clustering and Active Learning of Hyperspectral Images With Nonlinear Diffusion." 
% IEEE Transactions on Geoscience and Remote Sensing 57.3 (2019): 1829-1845.
%
% -Murphy, James M., and Mauro Maggioni. 
% "Spectral-Spatial Diffusion Geometry for Hyperspectral Image Clustering." 
% IEEE Geoscience and Remote Sensing Letters 17.7 (2020): 1243-1247.
%
% In order to run the main learning algorithms, one auxilliary directory is 
% required:
%
% DiffusionGeometry: https://mauromaggioni.duckdns.org/code/
%
% The main demonstration script is DiffusionLearningDemo.  To perform the 
% comparisons called in this script, the following auxilliary directories 
% are required:
%
% Sparse Manifold Clustering and Embedding (SMCE): http://www.vision.jhu.edu/code/
% Heirarchical Non-Negative Matrix Factorization (HNMF): https://www.dropbox.com/s/z254j7i2naoh75o/hierclust2nmf_v2.zip?dl=0
% Fast Independent Component Analysis (ICA): http://research.ics.aalto.fi/ica/fastica/code/dlcode.shtml
%
% In order to perform cluster alignment with the Hungarian algorithm, the
% following package is required: https://www.mathworks.com/matlabcentral/fileexchange/20328-munkres-assignment-algorithm
%
% (c) Copyright James M. Murphy, Tufts University, 2020.
